.386 
.model flat,stdcall 
option casemap:none 

include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc


includelib \masm32\lib\masm32.lib
includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib


RGB MACRO red, green, blue
  xor eax,eax
  mov ah,blue
  shl eax, 8
  mov ah,green
  mov al,red
endm 


WinMain proto :DWORD,:DWORD,:DWORD,:DWORD 
TopXY PROTO :DWORD,:DWORD

.DATA    
 ClassName db "WinClass",0   
 AppName db "Text Scroller",0  
 TMain db "mTimer",0
 YPos dd 0
 txt_Headers db "About",10,13,10,13,10,13,10,13
             db "Beta Testers",0 
 txt_Content db " Version. 1.0.1.0",10,13
             db " Created by Jackal  2007",10,13,10,13,10,13
             db " LilSarge",10,13
             db " Fred.nl",10,13
             db " Jet-WTF",10,13
             db " DC_Scout_67",0

.DATA? 
 hInstance HINSTANCE ? 
 CommandLine LPSTR ? 
 sWid dd ?
 sHgt dd ?

 hDCMain dd ?
 hDCBack dd ?
 hSaveDCBack dd ?
 hBTMBack dd ?
 hBrsBack dd ?

.CODE  
start: 
 Invoke GetModuleHandle, NULL 
 mov hInstance,eax 
 invoke GetCommandLine 
 mov CommandLine,eax 
 invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT 
 invoke ExitProcess, eax 

 WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD 
    LOCAL wc:WNDCLASSEX 
    LOCAL msg:MSG 
    LOCAL hwnd:HWND 
    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    invoke GetSystemMetrics,SM_CXSCREEN
    mov sWid, eax
    invoke GetSystemMetrics,SM_CYSCREEN
    mov sHgt, eax
    mov   wc.cbSize,SIZEOF WNDCLASSEX 
    mov   wc.style, CS_HREDRAW or CS_VREDRAW 
    mov   wc.lpfnWndProc, OFFSET WndProc 
    mov   wc.cbClsExtra,NULL 
    mov   wc.cbWndExtra,NULL 
    push  hInstance 
    pop   wc.hInstance 
    RGB 113,111,100
    invoke CreateSolidBrush, eax
    mov   wc.hbrBackground, eax
    mov   wc.lpszMenuName,NULL 
    mov   wc.lpszClassName,OFFSET ClassName 
    Invoke LoadIcon,NULL,IDI_APPLICATION
    mov   wc.hIcon,eax
    mov   wc.hIconSm,eax 
    invoke LoadCursor,NULL,IDC_ARROW 
    mov   wc.hCursor,eax 
    invoke RegisterClassEx, addr wc  
    mov Wwd, 250
    mov Wht, 100
    invoke TopXY,Wwd,sWid
    mov Wtx, eax
    invoke TopXY,Wht,sHgt
    mov Wty, eax
    invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR AppName, WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX, Wtx,Wty,Wwd,Wht,NULL,NULL, hInst,NULL
    mov   hwnd,eax 
    invoke ShowWindow, hwnd,CmdShow  
    invoke UpdateWindow, hwnd

    .WHILE TRUE 
                invoke GetMessage, ADDR msg,NULL,0,0 
                .BREAK .IF (!eax) 
                invoke TranslateMessage, ADDR msg 
                invoke DispatchMessage, ADDR msg 
   .ENDW 
    mov     eax,msg.wParam 
    ret 
 WinMain endp 

 WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM 
    LOCAL buffer[128]:BYTE
    LOCAL rect:RECT
    LOCAL ps:PAINTSTRUCT

   .IF uMsg==WM_DESTROY
     invoke KillTimer,hWnd, ADDR TMain
     Invoke RestoreDC,hDCBack,hSaveDCBack
     Invoke DeleteDC,hDCBack
     Invoke DeleteObject,hBTMBack
     Invoke DeleteObject, hBrsBack
     Invoke PostQuitMessage,NULL
   .ELSEIF uMsg==WM_CREATE
     Invoke SetTimer, hWnd, ADDR TMain, 20, NULL


    Invoke GetDC,hWnd
    mov hDCMain, eax
    Invoke CreateCompatibleDC, hDCMain
    mov hDCBack, eax
    Invoke SaveDC, hDCBack
    mov hSaveDCBack, eax
    Invoke CreateCompatibleBitmap, hDCMain,250,150
    mov hBTMBack, eax
    Invoke ReleaseDC,hWnd, hDCMain
    Invoke SelectObject,hDCBack, hBTMBack
    Invoke GetStockObject,NULL_PEN
    Invoke SelectObject,hDCBack,eax
    RGB 113,111,100
    Invoke CreateSolidBrush,eax
    mov hBrsBack,  eax
    Invoke SelectObject, hDCBack, eax
    Invoke Rectangle, hDCBack,0,0,250,300

    invoke GetStockObject, DEFAULT_GUI_FONT
    invoke SendMessage, hDCBack,WM_SETFONT,eax,TRUE

    RGB  146,174,120
    invoke SetTextColor,hDCBack,eax
    RGB 113,111,100
    invoke SetBkColor,hDCBack,eax
    mov YPos, 215
    mov rect.top, 0
    mov rect.bottom, 100
    mov rect.left, 10
    mov rect.right, 185
    invoke DrawText, hDCBack, ADDR txt_Headers, -1, ADDR rect, DT_NOCLIP


    RGB  174,174,174
    invoke SetTextColor,hDCBack,eax


    mov rect.top, 20
    mov rect.bottom, 100
    mov rect.left, 10
    mov rect.right, 200
    invoke DrawText, hDCBack, ADDR txt_Content, -1, ADDR rect, DT_NOCLIP




   .ELSEIF uMsg==WM_TIMER
     sub YPos, 1
     jnz @F
       mov YPos, 215
     @@:
     invoke InvalidateRect, hWnd, 0, FALSE
   .ELSEIF uMsg==WM_PAINT

      Invoke BeginPaint, hWnd,addr ps

      mov edx, YPos
      sub edx, 150
      Invoke BitBlt,ps.hdc, 0, edx, 250, 250, hDCBack, 0, 0, SRCCOPY
      Invoke EndPaint,hWnd,addr ps

   .ELSE 
        invoke DefWindowProc,hWnd,uMsg,wParam,lParam
        ret 
   .ENDIF 
   xor eax,eax 
   ret 
 WndProc endp 

 TopXY proc wDim:DWORD, sDim:DWORD
   mov eax, sDim
   sub eax, wDim
   shr eax, 1
   ret
 TopXY endp
end start 